Split feature on spatialite layers with primary key error

2013-04-08 03:45 PM - Olivier Dalang

Status: Closed

Priority: Severe/Regression

Assignee:

Category: Digitising

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution: fixed

Crashes QGIS or corrupts data:Yes Copied to github as #: 16493

Description

Hi !

As stated here: #7244

When you split a feature on a spatialite layer that has a primary key (as QGis proposes in the new spatialite layer window), you get the

following error:

Errors: ERROR: 2 feature(s) not added.

SUCCESS: 2 geometries were changed.

Provider errors:

  SQLite error: PRIMARY KEY must be unique

SQL: INSERT INTO "teste1"("geometry","pkuid","nome") VALUES (GeomFromWKB(?, 3003),?,?)

This is critical since after exiting edit mode, even if you discard the changes, you loose one part of the splitted feature !

Thanks !

Related issues:

Related to QGIS Application - Bug report # 5475: Problem to insert splitted g... Closed 2012-04-23

Related to QGIS Application - Bug report # 7244: Split multipolygon geometry ... Closed 2013-02-27

Related to QGIS Application - Bug report # 6060: QGIS 1.8 Split Features does... Closed 2012-07-18

History

#1 - 2013-05-19 10:17 AM - Giovanni Manghi

- Category set to Vectors

- Priority changed from High to Severe/Regression

I raise the priority even if I'm not sure if this is a regression, because we cannot ship qgis 2.0 with such critical issue.

#2 - 2013-05-29 10:56 PM - Denis Rouzaud

It occurs also with other providers and is very annoying.

#3 - 2013-06-02 02:27 AM - Giovanni Manghi
- Subject changed from Split feature on spatialite layers with primary key error to Split feature on spatialite/postgis layers with primary key error

#4 - 2013-06-06 10:03 AM - Giovanni Manghi

- Status changed from Open to Feedback

it seems fixed with PostGIS, but not with Spatialite, do you confirm?

#5 - 2013-06-06 10:06 AM - Giovanni Manghi

Giovanni Manghi wrote:

it seems fixed with PostGIS, but not with Spatialite, do you confirm?

unfortunately I have to correct myself, it is not fixed at all. Moreover when discarding edits features are lost.

#6 - 2013-06-20 12:52 AM - Giovanni Manghi

- Subject changed from Split feature on spatialite/postgis layers with primary key error to Split feature on spatialite layers with primary key error

uff... it is a roller coaster... it seems fixed for PostGIS but still an issue for SL, can you confirm?

#7 - 2013-06-28 01:24 AM - Giovanni Manghi

- Category changed from Vectors to Digitising

#8 - 2013-07-08 05:47 AM - Vincent Mora

- Assignee set to Vincent Mora

I can confirm that the problem is there with SL and not there with PostGIS.

#9 - 2013-07-09 06:48 AM - Vincent Mora

- File test_qgsspatialiteprovider.py added

Here is a simple test to reproduce the problem.

#10 - 2013-07-09 07:38 AM - Vincent Mora

There is a flaw in QgsVectorLayerEditBuffer::commitChanges IMO: in the case one of the operations (deleteFeature, addFeature...) fails, the edition

cannot be rolled back and the data are corrupted.

COMMIT/ROLLBACK are done after each operation and not globally for QgsVectorLayerEditBuffer::commitChanges.

This is not what this issue is about, but the problem is visible here (if a geometry is split in half, the second half cannot be added because of the non unique

key, and the first half replaces the initial geometry).
Maybe another issue ?

#11 - 2013-07-09 07:59 AM - Jürgen Fischer

Olivier Dalang wrote:

This is critical since after exiting edit mode, even if you discard the changes, you loose one part of the splitted feature!

You don't want to discard the changes, because you already have commited some of the changes (the 2 updates) and discarding the changes means you

loose the two pending additions.  You can still fix those by assigning a primary key, which they can be committed with.  Admittedly that's not very

convenient.

Maybe the split operation should bring up a dialog like the merge operation, that lets you set the attributes of the new features - possibly with an option to

reset them to a default value or NULL (which might produce a usable primary key).

The provider interface currently has no way to expose to the vector layer, which attributes make up the primary key (or if there even is an attribute based

primary key at all) nor to have full transactions, so that you can commit all or nothing.

#12 - 2013-07-09 08:21 AM - Vincent Mora

For the moment I'm planning to detect primary keys and add new keys for added features (what is done in postgres provider).

This should solve the bug and remain convenient for the user (who can still edit attributes afterward if needed).

#13 - 2013-07-09 08:36 AM - Jürgen Fischer

Vincent Mora wrote:

For the moment I'm planning to detect primary keys and add new keys for added features (what is done in postgres provider).

The solution for postgres layer was to reset the attributes to their default values in the split tool.  If the spatialite provider reported a NULL value as 

defaultValue for the primary key column, you'd be probably done.   In the postgres case that implies that there is a nextval call in default value and for the

spatialite case that would imply that the column is auto-incrementing.

#14 - 2013-07-09 08:40 AM - Jürgen Fischer

Jürgen Fischer wrote:

If the spatialite provider reported a NULL value as defaultValue for the primary key column, you'd be probably done.

Sorry, unfortunately the split tool explicitly ignores defaultValues that are NULL - because that's how columns without a default value are reported.

#15 - 2013-07-09 08:53 AM - Vincent Mora

OK, so I will start by implementing the getPrimaryKey() for the SL provider,
What you say is that if I set the key to NULL in addFeatures, sqlite generates a unique key for me ?

#16 - 2013-07-09 09:13 AM - Jürgen Fischer

Vincent Mora wrote:

OK, so I will start by implementing the getPrimaryKey() for the SL provider,

What you say is that if I set the key to NULL in addFeatures, sqlite generates a unique key for me ?

only if the column is set to auto_increment - but that's not mandatory.  So there could well be tables where that's not the case (but that wouldn't be handled

with postgres layers either).

#17 - 2013-07-09 09:16 AM - Vincent Mora

Jürgen Fischer wrote:

only if the column is set to auto_increment - but that's not mandatory.  So there could well be tables where that's not the case (but that wouldn't be

handled with postgres layers either).

So, back to the original plan (generate primary keys for new features) ?

#18 - 2013-07-09 09:21 AM - Jürgen Fischer

Vincent Mora wrote:

So, back to the original plan (generate primary keys for new features) ?

You have to draw a line somewhere anyway.  E.g. what do you do with a primary key that is made up from multiple columns?

#19 - 2013-07-09 01:08 PM - Vincent Mora

The issue is solved, here is the pull request: https://github.com/qgis/Quantum-GIS/pull/708

#20 - 2013-07-10 01:22 AM - Giovanni Manghi

- Pull Request or Patch supplied changed from No to Yes

#21 - 2013-07-10 05:59 AM - Vincent Mora

The defaultValue is not implemented for SL provider. As a result the pk value of a feature created by split is the same as the original feature (default

implementation of defaultValue).

I did implement pkAttributeIndexes for the SL provider.

Since Jürgen suggested the case where PK are not set to autoincrement, I reproduced the problem with a posgres database (primary key value not set to
autoincrement).

I'm planning to generate unique values for PK in split (if the field is not set to autoincrement), the user can then edit them manually if need be.

Your feedback is appreciated.

#22 - 2013-07-10 08:20 AM - Vincent Mora

After trying to generate unique primary key values in split, I realized that this is not an easy endeavor. Moreover, if the user has a primary key that does not

auto-increment, I'm not sure it should be done behind his/her back. So I'm back to square one: edition buffer fails to save (because of duplicate keys) and

corrupts data even if discarded what should be done.

I tried a very naive approach: in QgsVectorLayerEditBuffer::commitChanges(), stop to touch the database if an error is detected.

It seems to work fine. If the added features (added by split or otherwise) fail to comply to database requirements, the user can discard changes or edit the

attribute table to fix the problem. In case of discard, data are not affected.

Is this solution acceptable ?

While editing the feature table (fixing non unique PK) I stubled uppon another problem: if I change the key of the new feature, no problem, but if I change

the key of the original feature modified by the split, the geometry modification are lost (I end up with the original geometry).

Should it be considered to be the same issue ?

#23 - 2013-07-11 01:26 AM - Vincent Mora

Here is a new patch, along the line of what I proposed earlier: https://github.com/qgis/Quantum-GIS/pull/714

#24 - 2013-07-11 02:10 AM - Vincent Mora

- Pull Request or Patch supplied changed from Yes to No

Sorry for the PR with several commits in it. I'm going to fix that.

I also have a default behaviour with spatialite that is a bit better for the user, namely, in the split function, if a default value for primary keys is not found,

then the value is set to NULL: with spatialite provider it will allow sqlite to generate a unique pk in simple cases (e.g. primary key on single column) and to

have obvious things for the user to fix (NULL values) in the attribute table in more complex case (e.g. pk on multiple columns).

#25 - 2013-07-11 02:40 AM - Vincent Mora

- Pull Request or Patch supplied changed from No to Yes

https://github.com/qgis/Quantum-GIS/pull/715

#26 - 2013-07-16 03:43 AM - Hugo Mercier

- Resolution set to fixed

- Assignee changed from Vincent Mora to Nathan Woodrow
Nathan, are you ok with the supplied PR ? Can we close ?

#27 - 2013-07-16 08:45 AM - Jürgen Fischer

- Assignee deleted (Nathan Woodrow)

#28 - 2013-07-16 08:46 AM - Jürgen Fischer

- Status changed from Feedback to Closed

Pull request !#715 was merged.

#29 - 2013-07-16 08:49 AM - Vincent Mora

Bug fixed thanks to fundings from Agence de l'Eau Adour-Garonne.

#30 - 2017-09-22 04:07 PM - Jürgen Fischer

- Duplicated by Bug report #17185: Data loss when discarding changes in a PostGIS layer added

#31 - 2017-09-22 04:41 PM - Jürgen Fischer

- Duplicated by deleted (Bug report #17185: Data loss when discarding changes in a PostGIS layer)

Files

test_qgsspatialiteprovider.py 2.52 KB 2013-07-09 Vincent Mora
